#include "SiliconTorch.hpp"

// C++ system level
#include <cstring>     // memset, strncmp
#include <cstdlib>     // TODO: is this for memcpy?
#include <functional>

// ESP32 specific
#include "esp_err.h"
#include "esp_log.h"
#include "driver/gpio.h"
#include "driver/uart.h"
#include "freertos/FreeRTOS.h"
#include "freertos/queue.h"

// project specific
#include "CyanBusCRC.hpp"
#include <SpiderLib.hpp>

// qthing stuff
#include <qthing>

// misc
#include <nlohmann/json.hpp>


using json = nlohmann::json;


static const char* const TAG = "SiliconTorch";


namespace SiliconTorch {


  SiliconTorch::SiliconTorch() {

    ESP_LOGI(TAG, "My deviceTopic[ %s ]", deviceTopic().c_str());
    ESP_LOGI(TAG, "My deviceTopic[ %s ]", deviceTopic("foo", "bar", "baz", "spam", "eggs").c_str());
    ESP_LOGI(TAG, "My serviceTopic[ %s ]", serviceTopic("1337", "4242", "foo", "bar", "baz", "spam", "eggs", "4242", "1337").c_str());

    //serviceManager = new SiliconTorch::ServiceManager::ServiceManager();

  }


  void start() {

    //serviceManager->start();

  }


  nlohmann::json SiliconTorch::getDeviceJSON() const {
    json out;

    // TODO: fill in data!

    return out;
  }

  void SiliconTorch::publishDeviceJSON(bool pretty) const {
    str out = getDeviceJSON().dump(pretty ? 2 : -1);
    //qthing::publish_message(deviceTopic("XXYYZZ"), out);  // TODO: device topic!!
  }


}
